#ifndef _CASSERT_H_
#define _CASSERT_H_

// Based on work from http://www.boost.org/doc/html/boost_staticassert.html.
//
// CASSERT is a compile-time assert.

template <bool x> struct __CASSERT_FAILED__;
template <> struct __CASSERT_FAILED__ <true> { enum { value = 1 }; };
template <int x> struct __CASSERT_TEST {};

#define CASSERT(EXPR) \
	typedef __CASSERT_TEST <sizeof(__CASSERT_FAILED__ <(bool)(EXPR)>)> __CASSERT_TYPEDEF_##__LINE__


#endif // _CASSERT_H_

