/* --------------------------------------------------------------------------
        DNSInfoConstants.cpp

        Copyright (C) 2004 Jason Weiler, All Rights Reserved
   -------------------------------------------------------------------------- */

#include <string.h>
#include "DNSInfoConstants.h"

int FindValueByString(const char * pStr, const StrValAssoc_t * MapData, unsigned int MapSize)
{
	for (unsigned long tIdx=0; tIdx<MapSize; ++tIdx)
	{
		if (_stricmp(MapData[tIdx].String, pStr) == 0)
		{
			// we have a match
			return MapData[tIdx].Value;
		}
	}

	// index zero is our dummy catch all element
	return MapData[0].Value;
}


const char * FindStringByValue(int iValue, const StrValAssoc_t * MapData, unsigned int MapSize)
{
	// iterate the list of Query Types and look for our string
	for (unsigned long tIdx=0; tIdx<MapSize; ++tIdx)
	{
		if (MapData[tIdx].Value == iValue)
		{
			return MapData[tIdx].String;
		}
	}

	// index zero is our dummy catch all element
	return MapData[0].String;
}

const char * GetQueryTypeStr(EQueryType idx)
{
	return FindStringByValue(idx, g_QueryTypes, g_QueryTypesLen);
}

EQueryType GetQueryTypeVal(const char * str)
{
	return (EQueryType)FindValueByString(str, g_QueryTypes, g_QueryTypesLen);
}

const char * GetQueryClassStr(EQueryClass idx)
{
	return FindStringByValue(idx, g_QueryClasses, g_QueryClassesLen);
}

EQueryClass GetQueryClassVal(const char * str)
{
	return (EQueryClass)FindValueByString(str, g_QueryClasses, g_QueryClassesLen);
}

const char * GetQueryOpcodeStr(EQueryOpcode idx)
{
	return FindStringByValue(idx, g_QueryOpcodes, g_QueryOpcodesLen);
}

EQueryOpcode GetQueryOpcodeVal(const char * str)
{
	return (EQueryOpcode)FindValueByString(str, g_QueryOpcodes, g_QueryOpcodesLen);
}

