/* --------------------------------------------------------------------------
        DNSServerList.h

        Copyright (C) 2004 Jason Weiler, All Rights Reserved
   -------------------------------------------------------------------------- */

#ifndef _DNSSERVERLIST_H_
#define _DNSSERVERLIST_H_

#include <string>
#include <vector>

class DNSServerList
{
public:
	inline size_t GetServerCount() const { return m_ServerAddrs.size(); }
	unsigned long ScanRegistry();
	inline unsigned long GetNthAddr(unsigned int N) const { if (N < GetServerCount()) return m_ServerAddrs[N];
												return INADDR_NONE;}
	inline void ClearList() {m_ServerAddrs.clear();}

	bool AddServer(unsigned long ulAddr);

protected:
	unsigned long EnumDNSServers();
	unsigned long EnumDNSServersList(const std::string & sRegKey, const std::string & sRegName);
	unsigned long EnumDNSServers_2000(const std::string & sRegKey, const std::string & sRegName);
	unsigned long Alt_EnumDNSServers_9X(const std::string & sRegKey, const std::string & sRegName);
	
	unsigned long ParseAddDNSServerList(const std::string & sList);

	bool QueryRegistryKey(HKEY hBaseKey, const std::string & keyPath,
						const std::string & keyName, unsigned char * outData,
						unsigned long * outDataLen,
						unsigned long * outDataType);


protected:
	std::vector<unsigned long> m_ServerAddrs;
};

#endif // _DNSSERVERLIST_H_

