/* --------------------------------------------------------------------------
        DataBuffer.h

        Copyright (C) 2004 Jason Weiler, All Rights Reserved
   -------------------------------------------------------------------------- */

#ifndef _DATABUFFER_H_
#define _DATABUFFER_H_


class CDataBuffer
{
public:
	CDataBuffer();
	virtual ~CDataBuffer();

	unsigned char * GetDataPtr(size_t * outLen);
	const unsigned char * GetDataPtr(size_t * outLen) const;

	inline size_t Size() const { return m_DataLen; }

	virtual bool Append(const unsigned char * newData, size_t newDataLen);
	bool Set(const unsigned char * newData, size_t newDataLen);
	void Clear();
	bool Empty() const { return m_DataLen == 0; }

protected:
	bool CheckBufferSize(unsigned long reqBytes);

	unsigned char * m_Data;
	size_t m_DataLen;
	size_t m_BufferSize;
	size_t m_GrowSize;

};

#endif // _DATABUFFER_H_

