/* --------------------------------------------------------------------------
        IPTransactionNetworkFactory.cpp

        Copyright (C) 2004 Jason Weiler, All Rights Reserved
   -------------------------------------------------------------------------- */

#include "IPTransactionNetworkFactory.h"

IPTransactionNetwork * CreateIPTransactionNetwork(unsigned long type)
{
	IPTransactionNetwork * retval;

	switch (type)
	{
#ifndef _DONT_USE_TCPIPTRANSACTIONNETWORK_
	case IPTRANSACTIONNETWORK_TCP:
		retval = new TCPTransactionNetwork();
		break;
#endif

#ifndef _DONT_USE_UDPIPTRANSACTIONNETWORK_
	case IPTRANSACTIONNETWORK_UDP:
		retval = new UDPTransactionNetwork();
		break;
#endif

	default:
		retval = NULL;
		break;
	}

	return retval;
}

void DestroyIPTransactionNetwork(IPTransactionNetwork * pDeadNetwork)
{
	delete pDeadNetwork;

	return;
}

